******************************************************************************
*                                                                            *
*   PROGRAM: circ                                                            *
*                                                                            *
*   PURPOSE: Extract RHC and LHC field components from Awas output           *
*                                                                            *
******************************************************************************

	program circ

c	input from file wire.ffl
c	output to file wire.cp

	complex et,ep,er,el

	dimension ntheta(999),nphi(999),ntf(999),npf(999)

	open(file='wire.ffl',unit=1,status='old')
	open(file='wireffl.cp',unit=2)
	write(2,*)'     RHC/Etot [dB]   LHC/Etot [dB]  LinMax/LinMin [dB]'

	read(1,*,err=910,end=910)ngroup
	read(1,*,err=910,end=910)fstart,fstop,nf
	read(1,*,err=910,end=910)mode
	read(1,*,err=910,end=910)nport
	read(1,*,err=910,end=910)nwgroup
	npwe=0
	do i=1,nwgroup
	  read(1,*,err=910,end=910)etrw,etiw,eprw,epiw,tstart,
     1	  tstop,ntheta(i),pstart,pstop,nphi(i)
	  npwe=npwe+(ntheta(i)+1)*(nphi(i)+1)
	end do
	do i=1,ngroup
	  read(1,*,err=910,end=910)tfstart,
     1	  tfstop,ntf(i),pfstart,pfstop,npf(i)
	end do
	read(1,*,err=910,end=910)nn0
	read(1,*,err=910,end=910)nb0
	read(1,*,err=910,end=910)nport0
	do i=1,nn0
	  read(1,*,err=910,end=910)x0,y0,z0
	end do
	do i=1,nb0
	  read(1,*,err=910,end=910)join01,join02
	end do
	do i=1,nport0
	  read(1,*,err=910,end=910)iport0
	end do

	nffpoints=0
	do i=1,ngroup
	  nffpoints=nffpoints+(ntf(i)+1)*(npf(i)+1)
	end do

	if(mode.eq.-1) then
	  nexc=nport
	else if(mode.eq.0.or.mode.eq.1) then
	  nexc=1
	else if(mode.eq.3) then
	  nexc=1
	else
	  nexc=npwe
	end if

	nread=(nf+1)*nexc*nffpoints
	do i=1,nread
	  if(abs(mode).ne.3) then
	    read(1,*,err=910,end=910)etr,eti,epr,epi,g1
	  else
	    read(1,*,err=910,end=910)etr,eti,epr,epi,g1,g2,g3
	  end if
	  et=cmplx(etr,eti)
	  ep=cmplx(epr,epi)
	  er=0.5*(et+(0.,1.)*ep)
	  el=0.5*(et-(0.,1.)*ep)
	  etot=sqrt(abs(er)**2+abs(el)**2)+1.e-12
	  rgr=20.*log10(abs(er)/etot+1.e-12)
	  rgl=20.*log10(abs(el)/etot+1.e-12)
	  rlin=20.*log10((abs(el)+abs(er))/(abs(abs(el)-abs(er))+1.e-12))
	  write(2,*)rgr,rgl,rlin
	end do

910	end