******************************************************************************
*                                                                            *
*   PROGRAM: geoconv.for                                                     *
*                                                                            *
*   PURPOSE: Convert from old to new *.geo file format                       *
*                                                                            *
******************************************************************************

	program geoconv

	parameter (ndim=500)

	character*76 header(3)
	dimension x(ndim),y(ndim),z(ndim)
	dimension join(2,ndim),a(ndim),parload(10,ndim)
	integer*1 iload(3,ndim),igen(ndim)
	complex za(ndim),zb(ndim),zd(ndim)
	dimension iport(ndim),znom(ndim)
	complex emf(ndim)

	character*76 f_name

c	read the old geometry file name (without extension)

	write(*,101)
101	format(' File name? ',$)
	read(*,102)f_name
102	format(a76)

c	read the reference frequency for loadings (as set up in old Awas)

	write(*,103)
103	format(' Reference frequency [Hz]? ',$)
	read(*,*)fref
	if(fref.eq.0.) fref=300.e6

	open(file=f_name,unit=1,status='old')

	w=8.*atan(1.)*fref

	read(1,102)header(1)
	read(1,102)header(2)
	read(1,102)header(3)

	read(1,*)mode
	read(1,*)igp
	read(1,*)nn
	read(1,*)nb
	read(1,*)np
                                                                            
	do i=1,nn
	  read(1,*)x(i),y(i),z(i)
	end do

	do i=1,nb
	  read(1,*)join(1,i),join(2,i),id,a(i),za(i),zb(i),zd(i)
	  if(real(za(i)).ne.0.) then
	    iload(1,i)=1
	    parload(1,i)=real(za(i))
	  end if
	  if(imag(za(i)).gt.0.) then
	    iload(1,i)=iload(1,i)+2
	    parload(2,i)=imag(za(i))/w
	  else if(imag(za(i)).lt.0.) then
	    iload(1,i)=iload(1,i)+4
	    parload(3,i)=-1./(imag(za(i))*w)
	  end if

	  if(real(zb(i)).ne.0.) then
	    iload(2,i)=1
	    parload(4,i)=real(zb(i))
	  end if
	  if(imag(zb(i)).gt.0.) then
	    iload(2,i)=iload(2,i)+2
	    parload(5,i)=imag(zb(i))/w
	  else if(imag(zb(i)).lt.0.) then
	    iload(2,i)=iload(2,i)+4
	    parload(6,i)=-1./(imag(zb(i))*w)
	  end if

	  if(real(zd(i)).ne.0.) then
	    iload(3,i)=1
	    parload(7,i)=real(zd(i))
	  end if
	  if(imag(zd(i)).gt.0.) then
	    iload(3,i)=iload(3,i)+2
	    parload(8,i)=imag(zd(i))/w
	  else if(imag(zd(i)).lt.0.) then
	    iload(3,i)=iload(3,i)+4
	    parload(9,i)=-1./(imag(zd(i))*w)
	  end if

	end do

	do i=1,np
	  read(1,*)iport(i),emf(i),znom(i)
	  igen(i)=1
	end do

	close(1)

	open(file=f_name,unit=1)

	write(1,102)header(1)
	write(1,102)header(2)
	write(1,102)header(3)

	write(1,*)mode
	write(1,*)igp
	write(1,*)nn
	write(1,*)nb
	write(1,*)np
                                                                            
	do i=1,nn
	  write(1,*)x(i),y(i),z(i)
	end do

	do i=1,nb
	  write(1,*)join(1,i),join(2,i),a(i),
     1	  (iload(j,i),j=1,3),(parload(j,i),j=1,10)
	end do

	do i=1,np
	  write(1,*)iport(i),igen(i),emf(i),znom(i)
	end do

	close(1)

	end